<?php

namespace App\Importers\Image\Jobs;

use App\Models\Image;
use Illuminate\Bus\Batchable;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use \Throwable;
use Illuminate\Support\Facades\Log;

class FinishImageModification implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels, Batchable;

    public function __construct(public Image $image)
    {
    }

    public function handle(): void
    {
        if (method_exists($this, 'batch') && $this->batch()?->cancelled()) {
            return;
        }

        $this->image->fill([
            'isCover' => $this->getCoverFlag(),
            'isProcessing' => false,
        ]);
        $this->image->save();

        // TODO: Dispatch image cleaned event
    }

    private function getCoverFlag() : bool {
        if(!$this->image->album->hasCover && $this->image->album->images->sortBy('id')->first()->id == $this->image->id) {
            return true;
        }
        return false;
    }

    public function failed(?Throwable $exception): void
    {
        Log::error($exception, [
            'image' => $this->image,
        ]);
    }
}
